<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__ipc__sema_8c" kind="file" language="C++">
    <compoundname>cy_ipc_sema.c</compoundname>
    <includes local="yes" refid="cy__ipc__drv_8h">cy_ipc_drv.h</includes>
    <includes local="yes" refid="cy__ipc__sema_8h">cy_ipc_sema.h</includes>
    <includes local="yes" refid="cy__syslib_8h">cy_syslib.h</includes>
    <includes local="no">string.h</includes>
    <incdepgraph>
      <node id="297">
        <label>cy_ipc_sema.c</label>
        <link refid="cy__ipc__sema_8c" />
        <childnode refid="298" relation="include">
        </childnode>
      </node>
      <node id="298">
        <label>string.h</label>
      </node>
    </incdepgraph>
      <sectiondef kind="define">
      <memberdef id="cy__ipc__sema_8c_1a26d588291aa7fc0df4c0b6eedf643c4f" kind="define" prot="public" static="no">
        <name>CY_IPC_SEMA_PER_WORD_MASK</name>
        <initializer>(<ref kindref="member" refid="group__group__ipc__sema__macros_1ga7c011c5126248439921e442aab3c6b23">CY_IPC_SEMA_PER_WORD</ref> - 1ul)</initializer>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" bodystart="32" column="9" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" line="32" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="var">
      <memberdef id="cy__ipc__sema_8c_1a54fa6bf69b69ef2af20702665c66c99b" kind="variable" mutable="no" prot="public" static="yes">
        <type><ref kindref="compound" refid="struct_i_p_c___s_t_r_u_c_t___type">IPC_STRUCT_Type</ref> *</type>
        <definition>IPC_STRUCT_Type* cy_semaIpcStruct</definition>
        <argsstring />
        <name>cy_semaIpcStruct</name>
        <briefdescription>
        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" bodystart="35" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" line="35" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__ipc__sema__functions_1ga1cbc3b147c650c8716de10a1ee8423bd" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref></type>
        <definition>cy_en_ipcsema_status_t Cy_IPC_Sema_Init</definition>
        <argsstring>(uint32_t ipcChannel, uint32_t count, uint32_t memPtr[])</argsstring>
        <name>Cy_IPC_Sema_Init</name>
        <param>
          <type>uint32_t</type>
          <declname>ipcChannel</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>count</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>memPtr</declname>
          <array>[]</array>
        </param>
        <briefdescription>
<para>This function initializes the semaphores subsystem. </para>        </briefdescription>
        <detaileddescription>
<para>The user must create an array of unsigned 32-bit words to hold the semaphore bits. The number of semaphores will be the size of the array * 32. The total semaphores count will always be a multiple of 32.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;In a multi-CPU system this init function should be called with all initialized parameters on one CPU only to provide a pointer to SRAM that can be shared between all the CPUs in the system that will use semaphores. On other CPUs user must specify the IPC semaphores channel and pass 0 / NULL to count and memPtr parameters correspondingly.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ipcChannel</parametername>
</parameternamelist>
<parameterdescription>
<para>The IPC channel number used for semaphores</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>count</parametername>
</parameternamelist>
<parameterdescription>
<para>The maximum number of semaphores to be supported (multiple of 32).</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>memPtr</parametername>
</parameternamelist>
<parameterdescription>
<para>This points to the array of (count/32) words that contain the semaphore data.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Status of the operation </para></simplesect>
<parameterlist kind="retval"><parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_SUCCESS</parametername>
</parameternamelist>
<parameterdescription>
<para>Successfully initialized </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_BAD_PARAM</parametername>
</parameternamelist>
<parameterdescription>
<para>Memory pointer is NULL and count is not zero, or count not multiple of 32 </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_ERROR_LOCKED</parametername>
</parameternamelist>
<parameterdescription>
<para>Could not acquire semaphores IPC channel</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />set<sp />up<sp />a<sp />single<sp />semaphore<sp />channel<sp />for<sp />use<sp />in<sp />communicating<sp />between<sp />two<sp />cores<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_IPC_CHAN_INDEX<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(8UL)<sp /></highlight><highlight class="comment">/*<sp />Example<sp />of<sp />IPC<sp />channel<sp />index<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />(CY_CPU_CORTEX_M0P)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />data<sp />is<sp />usually<sp />allocated<sp />in<sp />CM0+<sp />memory<sp />space<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />mySemaData;<sp /></highlight><highlight class="comment">/*<sp />So<sp />there<sp />are<sp />32<sp />semaphores<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a3aa7b86b286b7666ee4482ae040d6d1b">CY_IPC_SEMA_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1ga1cbc3b147c650c8716de10a1ee8423bd">Cy_IPC_Sema_Init</ref>(MY_IPC_CHAN_INDEX,<sp />32UL,<sp />&amp;mySemaData))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Handle<sp />possible<sp />errors<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Therefore,<sp />enother<sp />core<sp />(usually<sp />CM4)<sp />initializes<sp />semaphore<sp />subsystem<sp />without<sp />data<sp />pointer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a3aa7b86b286b7666ee4482ae040d6d1b">CY_IPC_SEMA_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1ga1cbc3b147c650c8716de10a1ee8423bd">Cy_IPC_Sema_Init</ref>(MY_IPC_CHAN_INDEX,<sp />0UL,<sp />NULL))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Handle<sp />possible<sp />errors<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif<sp /><sp /></highlight><highlight class="comment">/*<sp />(CY_CPU_CORTEX_M0P)<sp />*/</highlight><highlight class="preprocessor" /></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="103" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" bodystart="72" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" line="72" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__sema__functions_1ga84360b76b923e0c249832a0c7690d589" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref></type>
        <definition>cy_en_ipcsema_status_t Cy_IPC_Sema_InitExt</definition>
        <argsstring>(uint32_t ipcChannel, cy_stc_ipc_sema_t *ipcSema)</argsstring>
        <name>Cy_IPC_Sema_InitExt</name>
        <param>
          <type>uint32_t</type>
          <declname>ipcChannel</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref> *</type>
          <declname>ipcSema</declname>
        </param>
        <briefdescription>
<para>This function initializes the semaphores subsystem. </para>        </briefdescription>
        <detaileddescription>
<para>The user must create an array of unsigned 32-bit words to hold the semaphore bits. The number of semaphores will be the size of the array * 32. The total semaphores count will always be a multiple of 32.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;In a multi-CPU system this init function should be called with all initialized parameters on one CPU only to provide a pointer to SRAM that can be shared between all the CPUs in the system that will use semaphores. On other CPUs user must specify the IPC semaphores channel and pass 0 / NULL to count and memPtr parameters correspondingly.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>ipcChannel</parametername>
</parameternamelist>
<parameterdescription>
<para>The IPC channel number used for semaphores</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>ipcSema</parametername>
</parameternamelist>
<parameterdescription>
<para>This is configuration structure of the IPC semaphore. See <ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Status of the operation </para></simplesect>
<parameterlist kind="retval"><parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_SUCCESS</parametername>
</parameternamelist>
<parameterdescription>
<para>Successfully initialized </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_BAD_PARAM</parametername>
</parameternamelist>
<parameterdescription>
<para>Memory pointer is NULL and count is not zero, or count not multiple of 32 </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_ERROR_LOCKED</parametername>
</parameternamelist>
<parameterdescription>
<para>Could not acquire semaphores IPC channel </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="189" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" bodystart="134" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" line="134" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__sema__functions_1ga455867cd3b817d61d355f0407221a9a9" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref></type>
        <definition>cy_en_ipcsema_status_t Cy_IPC_Sema_Set</definition>
        <argsstring>(uint32_t semaNumber, bool preemptable)</argsstring>
        <name>Cy_IPC_Sema_Set</name>
        <param>
          <type>uint32_t</type>
          <declname>semaNumber</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>preemptable</declname>
        </param>
        <briefdescription>
<para>This function tries to acquire a semaphore. </para>        </briefdescription>
        <detaileddescription>
<para>If the semaphore is not available, this function returns immediately with CY_IPC_SEMA_LOCKED.</para><para>It first acquires the IPC channel that is used for all the semaphores, sets the semaphore if it is cleared, then releases the IPC channel used for the semaphore.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>semaNumber</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore number to acquire.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>preemptable</parametername>
</parameternamelist>
<parameterdescription>
<para>When this parameter is enabled the function can be preempted by another task or other forms of context switching in an RTOS environment.</para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If &lt;b&gt;preemptable&lt;/b&gt; is enabled (true), the user must ensure that there are no deadlocks in the system, which can be caused by an interrupt that occurs after the IPC channel is locked. Unless the user is ready to handle IPC channel locks correctly at the application level, set &lt;b&gt;preemptable&lt;/b&gt; to false.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="return"><para>Status of the operation </para></simplesect>
<parameterlist kind="retval"><parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_SUCCESS</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore was set successfully </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_LOCKED</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore channel is busy or locked by another process </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_NOT_ACQUIRED</parametername>
</parameternamelist>
<parameterdescription>
<para>Semaphore was already set </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_OUT_OF_RANGE</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore number is not valid</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />set<sp />semaphore<sp />#MY_SEMA_NUM<sp />to<sp />inform<sp />the<sp />other<sp />core</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />of<sp />the<sp />intention<sp />to<sp />perform<sp />some<sp />action.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_SEMA_NUM<sp />(3UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__ipc__sema__functions_1ga455867cd3b817d61d355f0407221a9a9">Cy_IPC_Sema_Set</ref>(MY_SEMA_NUM,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a3aa7b86b286b7666ee4482ae040d6d1b">CY_IPC_SEMA_SUCCESS</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />is<sp />set<sp />successfully<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a626c7f517e6dbd4f20281b4fa42300ed">CY_IPC_SEMA_LOCKED</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />channel<sp />is<sp />busy<sp />or<sp />locked<sp />by<sp />another<sp />process<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a21f1c980ff46f66bd0bef3ff5958204b">CY_IPC_SEMA_NOT_ACQUIRED</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Semaphore<sp />is<sp />already<sp />set<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a143eff28bd0bc98a860fce473075d1ac">CY_IPC_SEMA_OUT_OF_RANGE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />number<sp />is<sp />not<sp />valid<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">default</highlight><highlight class="normal">:<sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="280" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" bodystart="229" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" line="229" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__sema__functions_1gaec88ff547d0d3185e7336c78a7411781" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref></type>
        <definition>cy_en_ipcsema_status_t Cy_IPC_Sema_Clear</definition>
        <argsstring>(uint32_t semaNumber, bool preemptable)</argsstring>
        <name>Cy_IPC_Sema_Clear</name>
        <param>
          <type>uint32_t</type>
          <declname>semaNumber</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>preemptable</declname>
        </param>
        <briefdescription>
<para>This functions tries to releases a semaphore. </para>        </briefdescription>
        <detaileddescription>
<para>It first acquires the IPC channel that is used for all the semaphores, clears the semaphore if it is set, then releases the IPC channel used for the semaphores.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>semaNumber</parametername>
</parameternamelist>
<parameterdescription>
<para>The index of the semaphore to release.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>preemptable</parametername>
</parameternamelist>
<parameterdescription>
<para>When this parameter is enabled the function can be preempted by another task or other forms of context switching in an RTOS environment.</para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If &lt;b&gt;preemptable&lt;/b&gt; is enabled (true), the user must ensure that there are no deadlocks in the system, which can be caused by an interrupt that occurs after the IPC channel is locked. Unless the user is ready to handle IPC channel locks correctly at the application level, set &lt;b&gt;preemptable&lt;/b&gt; to false.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="return"><para>Status of the operation </para></simplesect>
<parameterlist kind="retval"><parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_SUCCESS</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore was cleared successfully </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_NOT_ACQUIRED</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore was already cleared </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_LOCKED</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore channel was semaphored or busy </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_OUT_OF_RANGE</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore number is not valid</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />action<sp />is<sp />completed.<sp />Clear<sp />the<sp />semaphore<sp />#MY_SEMA_NUM<sp />to<sp />inform</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />the<sp />other<sp />core<sp />that<sp />the<sp />action<sp />is<sp />already<sp />completed.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_SEMA_NUM<sp />(3UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__ipc__sema__functions_1gaec88ff547d0d3185e7336c78a7411781">Cy_IPC_Sema_Clear</ref>(MY_SEMA_NUM,<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a3aa7b86b286b7666ee4482ae040d6d1b">CY_IPC_SEMA_SUCCESS</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />is<sp />cleared<sp />successfully<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a626c7f517e6dbd4f20281b4fa42300ed">CY_IPC_SEMA_LOCKED</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />channel<sp />is<sp />busy<sp />or<sp />locked<sp />by<sp />another<sp />process<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a21f1c980ff46f66bd0bef3ff5958204b">CY_IPC_SEMA_NOT_ACQUIRED</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*Semaphore<sp />is<sp />already<sp />cleared<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a143eff28bd0bc98a860fce473075d1ac">CY_IPC_SEMA_OUT_OF_RANGE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />number<sp />is<sp />not<sp />valid<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">default</highlight><highlight class="normal">:<sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="367" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" bodystart="317" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" line="317" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__sema__functions_1gaaa39cd088ef1e2ee9cd0555ae733c98f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref></type>
        <definition>cy_en_ipcsema_status_t Cy_IPC_Sema_Status</definition>
        <argsstring>(uint32_t semaNumber)</argsstring>
        <name>Cy_IPC_Sema_Status</name>
        <param>
          <type>uint32_t</type>
          <declname>semaNumber</declname>
        </param>
        <briefdescription>
<para>This function returns the status of the semaphore. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>semaNumber</parametername>
</parameternamelist>
<parameterdescription>
<para>The index of the semaphore to return status.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Status of the operation </para></simplesect>
<parameterlist kind="retval"><parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_STATUS_LOCKED</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore is in the set state. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_STATUS_UNLOCKED</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore is in the cleared state. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>CY_IPC_SEMA_OUT_OF_RANGE</parametername>
</parameternamelist>
<parameterdescription>
<para>The semaphore number is not valid</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />check<sp />the<sp />state<sp />of<sp />semaphore<sp />#3.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_SEMA_NUM<sp />(3UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__ipc__sema__functions_1gaaa39cd088ef1e2ee9cd0555ae733c98f">Cy_IPC_Sema_Status</ref>(MY_SEMA_NUM))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a920300a84a7ca2e96ce187423ac2eb18">CY_IPC_SEMA_STATUS_LOCKED</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />is<sp />in<sp />the<sp />set<sp />state<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9af009b6acf4579107d5384100f9f2e60c">CY_IPC_SEMA_STATUS_UNLOCKED</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />is<sp />in<sp />the<sp />cleared<sp />state<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a143eff28bd0bc98a860fce473075d1ac">CY_IPC_SEMA_OUT_OF_RANGE</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />semaphore<sp />number<sp />is<sp />not<sp />valid<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">default</highlight><highlight class="normal">:<sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="418" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" bodystart="388" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" line="388" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__sema__functions_1gaf8dd9fc553a66939d37a988fa17eb3c1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t Cy_IPC_Sema_GetMaxSems</definition>
        <argsstring>(void)</argsstring>
        <name>Cy_IPC_Sema_GetMaxSems</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>This function returns the number of semaphores in the semaphores subsystem. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>Returns the semaphores quantity.</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />get<sp />the<sp />maximum<sp />number<sp />of<sp />configured<sp />semaphores</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />and<sp />check<sp />if<sp />the<sp />MY_SEMA_NUM<sp />is<sp />valid.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_SEMA_NUM<sp />(3UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(MY_SEMA_NUM<sp />&lt;<sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1gaf8dd9fc553a66939d37a988fa17eb3c1">Cy_IPC_Sema_GetMaxSems</ref>())</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />MY_SEMA_NUM<sp />is<sp />valid<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="442" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" bodystart="434" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" line="434" />
      </memberdef>
      </sectiondef>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
<para><simplesect kind="version"><para>1.40.1</para></simplesect>
Description: IPC Semaphore Driver - This source file contains the source code for the semaphore level APIs for the IPC interface.</para><para>Copyright 2016-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para><para>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="26"><highlight class="preprocessor">#include<sp />"cy_ipc_drv.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="27"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_ipc_sema.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_syslib.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;string.h&gt;</highlight><highlight class="normal"><sp /></highlight><highlight class="comment">/*<sp />The<sp />memset()<sp />definition<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /><highlight class="comment">/*<sp />Defines<sp />a<sp />mask<sp />to<sp />Check<sp />if<sp />semaphore<sp />count<sp />is<sp />a<sp />multiple<sp />of<sp />32<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_IPC_SEMA_PER_WORD_MASK<sp /><sp /><sp /><sp />(CY_IPC_SEMA_PER_WORD<sp />-<sp />1ul)</highlight><highlight class="normal" /></codeline>
<codeline lineno="33"><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /><highlight class="comment">/*<sp />Pointer<sp />to<sp />IPC<sp />structure<sp />used<sp />for<sp />semaphores<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="struct_i_p_c___s_t_r_u_c_t___type">IPC_STRUCT_Type</ref>*<sp />cy_semaIpcStruct;</highlight></codeline>
<codeline lineno="36"><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="39"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_IPC_Sema_Init</highlight></codeline>
<codeline lineno="40"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="72"><highlight class="normal"><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1ga1cbc3b147c650c8716de10a1ee8423bd">Cy_IPC_Sema_Init</ref>(uint32_t<sp />ipcChannel,</highlight></codeline>
<codeline lineno="73"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />count,<sp />uint32_t<sp />memPtr[])</highlight></codeline>
<codeline lineno="74"><highlight class="normal">{</highlight></codeline>
<codeline lineno="75"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Structure<sp />containing<sp />semaphores<sp />control<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="76"><highlight class="normal"><sp /><sp /><sp /><sp />CY_SECTION(</highlight><highlight class="stringliteral">".cy_sharedmem"</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="77"><highlight class="normal"><sp /><sp /><sp /><sp />static<sp /><ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_semaData;</highlight></codeline>
<codeline lineno="78"><highlight class="normal" /></codeline>
<codeline lineno="79"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a1b66325842ee041773708d951ac7e13a">CY_IPC_SEMA_BAD_PARAM</ref>;</highlight></codeline>
<codeline lineno="80"><highlight class="normal" /></codeline>
<codeline lineno="81"><highlight class="normal"><sp /><sp /><sp /><sp />if(<sp />(NULL<sp />==<sp />memPtr)<sp />&amp;&amp;<sp />(0u<sp />==<sp />count))</highlight></codeline>
<codeline lineno="82"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="83"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_semaIpcStruct<sp />=<sp /><ref kindref="member" refid="group__group__ipc__functions_1gaa1ca9b002b286f12fde442c8653aa3bf">Cy_IPC_Drv_GetIpcBaseAddress</ref>(ipcChannel);</highlight></codeline>
<codeline lineno="84"><highlight class="normal" /></codeline>
<codeline lineno="85"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a3aa7b86b286b7666ee4482ae040d6d1b">CY_IPC_SEMA_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="86"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="87"><highlight class="normal" /></codeline>
<codeline lineno="88"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />for<sp />non<sp />Null<sp />pointers<sp />and<sp />count<sp />value<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="89"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((NULL<sp />!=<sp />memPtr)<sp />&amp;&amp;<sp />(0u<sp />!=<sp />count))</highlight></codeline>
<codeline lineno="90"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="91"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_semaData.maxSema<sp /><sp />=<sp />count;</highlight></codeline>
<codeline lineno="92"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_semaData.arrayPtr<sp />=<sp />memPtr;</highlight></codeline>
<codeline lineno="93"><highlight class="normal" /></codeline>
<codeline lineno="94"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1ga84360b76b923e0c249832a0c7690d589">Cy_IPC_Sema_InitExt</ref>(ipcChannel,<sp />&amp;cy_semaData);</highlight></codeline>
<codeline lineno="95"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="96"><highlight class="normal" /></codeline>
<codeline lineno="97"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="98"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="99"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a1b66325842ee041773708d951ac7e13a">CY_IPC_SEMA_BAD_PARAM</ref>;</highlight></codeline>
<codeline lineno="100"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="101"><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal">(retStatus);</highlight></codeline>
<codeline lineno="103"><highlight class="normal">}</highlight></codeline>
<codeline lineno="104"><highlight class="normal" /></codeline>
<codeline lineno="105"><highlight class="normal" /></codeline>
<codeline lineno="106"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="107"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_IPC_Sema_InitExt</highlight></codeline>
<codeline lineno="108"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="134"><highlight class="normal"><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1ga84360b76b923e0c249832a0c7690d589">Cy_IPC_Sema_InitExt</ref>(uint32_t<sp />ipcChannel,<sp /><ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp />*ipcSema)</highlight></codeline>
<codeline lineno="135"><highlight class="normal">{</highlight></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a1b66325842ee041773708d951ac7e13a">CY_IPC_SEMA_BAD_PARAM</ref>;</highlight></codeline>
<codeline lineno="137"><highlight class="normal" /></codeline>
<codeline lineno="138"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(ipcChannel<sp />&gt;=<sp />CY_IPC_CHANNELS)</highlight></codeline>
<codeline lineno="139"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="140"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a1b66325842ee041773708d951ac7e13a">CY_IPC_SEMA_BAD_PARAM</ref>;</highlight></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="142"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="144"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(NULL<sp />!=<sp />ipcSema)</highlight></codeline>
<codeline lineno="145"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="146"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />if<sp />semaphore<sp />count<sp />is<sp />a<sp />multiple<sp />of<sp />32<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="147"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<sp />0ul<sp />==<sp />(ipcSema-&gt;<ref kindref="member" refid="structcy__stc__ipc__sema__t_1a5f5f482e9c7bf7992001adb225f5d811">maxSema</ref><sp />&amp;<sp />CY_IPC_SEMA_PER_WORD_MASK))</highlight></codeline>
<codeline lineno="148"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="149"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />cy_semaIpcStruct<sp />=<sp /><ref kindref="member" refid="group__group__ipc__functions_1gaa1ca9b002b286f12fde442c8653aa3bf">Cy_IPC_Drv_GetIpcBaseAddress</ref>(ipcChannel);</highlight></codeline>
<codeline lineno="150"><highlight class="normal" /></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />all<sp />semaphores<sp />to<sp />released<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="152"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)memset(ipcSema-&gt;<ref kindref="member" refid="structcy__stc__ipc__sema__t_1ad04fb13a0736977c4ddc642a630c9f54">arrayPtr</ref>,<sp />0,<sp />(ipcSema-&gt;<ref kindref="member" refid="structcy__stc__ipc__sema__t_1a5f5f482e9c7bf7992001adb225f5d811">maxSema</ref><sp />/8u));</highlight></codeline>
<codeline lineno="153"><highlight class="normal" /></codeline>
<codeline lineno="154"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Make<sp />sure<sp />semaphores<sp />start<sp />out<sp />released.<sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="155"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Ignore<sp />the<sp />return<sp />value<sp />since<sp />it<sp />is<sp />OK<sp />if<sp />it<sp />was<sp />already<sp />released.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)<sp /><ref kindref="member" refid="group__group__ipc__functions_1ga7c675e2c6b20599160bfb0046cfee109">Cy_IPC_Drv_LockRelease</ref><sp />(cy_semaIpcStruct,<sp /><ref kindref="member" refid="group__group__ipc__macros_1ga8c02b33010a796cc0d610491bda52827">CY_IPC_NO_NOTIFICATION</ref>);</highlight></codeline>
<codeline lineno="157"><highlight class="normal" /></codeline>
<codeline lineno="158"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />the<sp />IPC<sp />Data<sp />with<sp />the<sp />pointer<sp />to<sp />the<sp />array.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="159"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<sp /><ref kindref="member" refid="group__group__ipc__enums_1ggab838549fe808bd6cb1bfc52d2b5cbf25a8748b3bf3a2b39bd469c0d41217a2cb2">CY_IPC_DRV_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__ipc__functions_1gab9e1b6079cd81d9b918b354d9437744d">Cy_IPC_Drv_SendMsgPtr</ref><sp />(cy_semaIpcStruct,<sp /><ref kindref="member" refid="group__group__ipc__macros_1ga8c02b33010a796cc0d610491bda52827">CY_IPC_NO_NOTIFICATION</ref>,<sp />ipcSema))</highlight></codeline>
<codeline lineno="160"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="161"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__ipc__enums_1ggab838549fe808bd6cb1bfc52d2b5cbf25a8748b3bf3a2b39bd469c0d41217a2cb2">CY_IPC_DRV_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__ipc__functions_1ga7c675e2c6b20599160bfb0046cfee109">Cy_IPC_Drv_LockRelease</ref><sp />(cy_semaIpcStruct,<sp /><ref kindref="member" refid="group__group__ipc__macros_1ga8c02b33010a796cc0d610491bda52827">CY_IPC_NO_NOTIFICATION</ref>))</highlight></codeline>
<codeline lineno="162"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a3aa7b86b286b7666ee4482ae040d6d1b">CY_IPC_SEMA_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="164"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="167"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />IPC<sp />channel<sp />not<sp />released,<sp />still<sp />semaphored<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="168"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9ac7fd96eac1a979c946eb27c35f69ea77">CY_IPC_SEMA_ERROR_LOCKED</ref>;</highlight></codeline>
<codeline lineno="169"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="170"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="171"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="172"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="173"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Could<sp />not<sp />acquire<sp />semaphore<sp />channel<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="174"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9ac7fd96eac1a979c946eb27c35f69ea77">CY_IPC_SEMA_ERROR_LOCKED</ref>;</highlight></codeline>
<codeline lineno="175"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="178"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="179"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a1b66325842ee041773708d951ac7e13a">CY_IPC_SEMA_BAD_PARAM</ref>;</highlight></codeline>
<codeline lineno="180"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="182"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="183"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="184"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a1b66325842ee041773708d951ac7e13a">CY_IPC_SEMA_BAD_PARAM</ref>;</highlight></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="187"><highlight class="normal" /></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal">(retStatus);</highlight></codeline>
<codeline lineno="189"><highlight class="normal">}</highlight></codeline>
<codeline lineno="190"><highlight class="normal" /></codeline>
<codeline lineno="191"><highlight class="normal" /></codeline>
<codeline lineno="192"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="193"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_IPC_Sema_Set</highlight></codeline>
<codeline lineno="194"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="229"><highlight class="normal"><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1ga455867cd3b817d61d355f0407221a9a9">Cy_IPC_Sema_Set</ref>(uint32_t<sp />semaNumber,<sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />preemptable)</highlight></codeline>
<codeline lineno="230"><highlight class="normal">{</highlight></codeline>
<codeline lineno="231"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />semaIndex;</highlight></codeline>
<codeline lineno="232"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />semaMask;</highlight></codeline>
<codeline lineno="233"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />interruptState<sp />=<sp />0ul;</highlight></codeline>
<codeline lineno="234"><highlight class="normal" /></codeline>
<codeline lineno="235"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp /><sp /><sp /><sp /><sp /><sp />*semaStruct;</highlight></codeline>
<codeline lineno="236"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a626c7f517e6dbd4f20281b4fa42300ed">CY_IPC_SEMA_LOCKED</ref>;</highlight></codeline>
<codeline lineno="237"><highlight class="normal" /></codeline>
<codeline lineno="238"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />pointer<sp />to<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="239"><highlight class="normal"><sp /><sp /><sp /><sp />semaStruct<sp />=<sp />(<ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp />*)Cy_IPC_Drv_ReadDataValue(cy_semaIpcStruct);</highlight></codeline>
<codeline lineno="240"><highlight class="normal" /></codeline>
<codeline lineno="241"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(semaNumber<sp />&lt;<sp />semaStruct-&gt;maxSema)</highlight></codeline>
<codeline lineno="242"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="243"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />semaIndex<sp />=<sp />semaNumber<sp />/<sp /><ref kindref="member" refid="group__group__ipc__sema__macros_1ga7c011c5126248439921e442aab3c6b23">CY_IPC_SEMA_PER_WORD</ref>;</highlight></codeline>
<codeline lineno="244"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />semaMask<sp />=<sp />(uint32_t)(1ul<sp />&lt;&lt;<sp />(semaNumber<sp />-<sp />(semaIndex<sp />*<sp /><ref kindref="member" refid="group__group__ipc__sema__macros_1ga7c011c5126248439921e442aab3c6b23">CY_IPC_SEMA_PER_WORD</ref>)<sp />));</highlight></codeline>
<codeline lineno="245"><highlight class="normal" /></codeline>
<codeline lineno="246"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!preemptable)</highlight></codeline>
<codeline lineno="247"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="248"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />interruptState<sp />=<sp /><ref kindref="member" refid="group__group__syslib__functions_1gae679f15a1702c159c105b596a8801105">Cy_SysLib_EnterCriticalSection</ref>();</highlight></codeline>
<codeline lineno="249"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="250"><highlight class="normal" /></codeline>
<codeline lineno="251"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />to<sp />make<sp />sure<sp />the<sp />IPC<sp />channel<sp />is<sp />released</highlight></codeline>
<codeline lineno="252"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />If<sp />so,<sp />check<sp />if<sp />specific<sp />channel<sp />can<sp />be<sp />locked.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="253"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__ipc__enums_1ggab838549fe808bd6cb1bfc52d2b5cbf25a8748b3bf3a2b39bd469c0d41217a2cb2">CY_IPC_DRV_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__ipc__functions_1ga8691465b9797f0b764505e9c77d41b02">Cy_IPC_Drv_LockAcquire</ref><sp />(cy_semaIpcStruct))</highlight></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="255"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">((semaStruct-&gt;<ref kindref="member" refid="structcy__stc__ipc__sema__t_1ad04fb13a0736977c4ddc642a630c9f54">arrayPtr</ref>[semaIndex]<sp />&amp;<sp />semaMask)<sp />==<sp />0ul)</highlight></codeline>
<codeline lineno="256"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="257"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />semaStruct-&gt;<ref kindref="member" refid="structcy__stc__ipc__sema__t_1ad04fb13a0736977c4ddc642a630c9f54">arrayPtr</ref>[semaIndex]<sp />|=<sp />semaMask;</highlight></codeline>
<codeline lineno="258"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a3aa7b86b286b7666ee4482ae040d6d1b">CY_IPC_SEMA_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="260"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="261"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="262"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a21f1c980ff46f66bd0bef3ff5958204b">CY_IPC_SEMA_NOT_ACQUIRED</ref>;</highlight></codeline>
<codeline lineno="263"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="264"><highlight class="normal" /></codeline>
<codeline lineno="265"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Release,<sp />but<sp />do<sp />not<sp />trigger<sp />a<sp />release<sp />event<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="266"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)<sp /><ref kindref="member" refid="group__group__ipc__functions_1ga7c675e2c6b20599160bfb0046cfee109">Cy_IPC_Drv_LockRelease</ref><sp />(cy_semaIpcStruct,<sp /><ref kindref="member" refid="group__group__ipc__macros_1ga8c02b33010a796cc0d610491bda52827">CY_IPC_NO_NOTIFICATION</ref>);</highlight></codeline>
<codeline lineno="267"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="268"><highlight class="normal" /></codeline>
<codeline lineno="269"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!preemptable)</highlight></codeline>
<codeline lineno="270"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="271"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__syslib__functions_1ga8c16343c075610b2888b0693f972b555">Cy_SysLib_ExitCriticalSection</ref>(interruptState);</highlight></codeline>
<codeline lineno="272"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="273"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="274"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="275"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="276"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a143eff28bd0bc98a860fce473075d1ac">CY_IPC_SEMA_OUT_OF_RANGE</ref>;</highlight></codeline>
<codeline lineno="277"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="278"><highlight class="normal" /></codeline>
<codeline lineno="279"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal">(retStatus);</highlight></codeline>
<codeline lineno="280"><highlight class="normal">}</highlight></codeline>
<codeline lineno="281"><highlight class="normal" /></codeline>
<codeline lineno="282"><highlight class="normal" /></codeline>
<codeline lineno="283"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="284"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_IPC_Sema_Clear</highlight></codeline>
<codeline lineno="285"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="317"><highlight class="normal"><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1gaec88ff547d0d3185e7336c78a7411781">Cy_IPC_Sema_Clear</ref>(uint32_t<sp />semaNumber,<sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />preemptable)</highlight></codeline>
<codeline lineno="318"><highlight class="normal">{</highlight></codeline>
<codeline lineno="319"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />semaIndex;</highlight></codeline>
<codeline lineno="320"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />semaMask;</highlight></codeline>
<codeline lineno="321"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />interruptState<sp />=<sp />0ul;</highlight></codeline>
<codeline lineno="322"><highlight class="normal" /></codeline>
<codeline lineno="323"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp /><sp /><sp /><sp /><sp /><sp />*semaStruct;</highlight></codeline>
<codeline lineno="324"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a626c7f517e6dbd4f20281b4fa42300ed">CY_IPC_SEMA_LOCKED</ref>;</highlight></codeline>
<codeline lineno="325"><highlight class="normal" /></codeline>
<codeline lineno="326"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />pointer<sp />to<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="327"><highlight class="normal"><sp /><sp /><sp /><sp />semaStruct<sp />=<sp />(<ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp />*)Cy_IPC_Drv_ReadDataValue(cy_semaIpcStruct);</highlight></codeline>
<codeline lineno="328"><highlight class="normal" /></codeline>
<codeline lineno="329"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(semaNumber<sp />&lt;<sp />semaStruct-&gt;maxSema)</highlight></codeline>
<codeline lineno="330"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="331"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />semaIndex<sp />=<sp />semaNumber<sp />/<sp /><ref kindref="member" refid="group__group__ipc__sema__macros_1ga7c011c5126248439921e442aab3c6b23">CY_IPC_SEMA_PER_WORD</ref>;</highlight></codeline>
<codeline lineno="332"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />semaMask<sp />=<sp />(uint32_t)(1ul<sp />&lt;&lt;<sp />(semaNumber<sp />-<sp />(semaIndex<sp />*<sp />CY_IPC_SEMA_PER_WORD)<sp />));</highlight></codeline>
<codeline lineno="333"><highlight class="normal" /></codeline>
<codeline lineno="334"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!preemptable)</highlight></codeline>
<codeline lineno="335"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="336"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />interruptState<sp />=<sp /><ref kindref="member" refid="group__group__syslib__functions_1gae679f15a1702c159c105b596a8801105">Cy_SysLib_EnterCriticalSection</ref>();</highlight></codeline>
<codeline lineno="337"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="338"><highlight class="normal" /></codeline>
<codeline lineno="339"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />to<sp />make<sp />sure<sp />the<sp />IPC<sp />channel<sp />is<sp />released</highlight></codeline>
<codeline lineno="340"><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />If<sp />so,<sp />check<sp />if<sp />specific<sp />channel<sp />can<sp />be<sp />locked.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="341"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__ipc__enums_1ggab838549fe808bd6cb1bfc52d2b5cbf25a8748b3bf3a2b39bd469c0d41217a2cb2">CY_IPC_DRV_SUCCESS</ref><sp />==<sp /><ref kindref="member" refid="group__group__ipc__functions_1ga8691465b9797f0b764505e9c77d41b02">Cy_IPC_Drv_LockAcquire</ref><sp />(cy_semaIpcStruct))</highlight></codeline>
<codeline lineno="342"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="343"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">((semaStruct-&gt;<ref kindref="member" refid="structcy__stc__ipc__sema__t_1ad04fb13a0736977c4ddc642a630c9f54">arrayPtr</ref>[semaIndex]<sp />&amp;<sp />semaMask)<sp />!=<sp />0ul)</highlight></codeline>
<codeline lineno="344"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="345"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />semaStruct-&gt;<ref kindref="member" refid="structcy__stc__ipc__sema__t_1ad04fb13a0736977c4ddc642a630c9f54">arrayPtr</ref>[semaIndex]<sp />&amp;=<sp />~semaMask;</highlight></codeline>
<codeline lineno="346"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a3aa7b86b286b7666ee4482ae040d6d1b">CY_IPC_SEMA_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="347"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="348"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="349"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="350"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a21f1c980ff46f66bd0bef3ff5958204b">CY_IPC_SEMA_NOT_ACQUIRED</ref>;</highlight></codeline>
<codeline lineno="351"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="352"><highlight class="normal" /></codeline>
<codeline lineno="353"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Release,<sp />but<sp />do<sp />not<sp />trigger<sp />a<sp />release<sp />event<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="354"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)<sp /><ref kindref="member" refid="group__group__ipc__functions_1ga7c675e2c6b20599160bfb0046cfee109">Cy_IPC_Drv_LockRelease</ref><sp />(cy_semaIpcStruct,<sp /><ref kindref="member" refid="group__group__ipc__macros_1ga8c02b33010a796cc0d610491bda52827">CY_IPC_NO_NOTIFICATION</ref>);</highlight></codeline>
<codeline lineno="355"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="356"><highlight class="normal" /></codeline>
<codeline lineno="357"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!preemptable)</highlight></codeline>
<codeline lineno="358"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="359"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__syslib__functions_1ga8c16343c075610b2888b0693f972b555">Cy_SysLib_ExitCriticalSection</ref>(interruptState);</highlight></codeline>
<codeline lineno="360"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="361"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="362"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="363"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="364"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a143eff28bd0bc98a860fce473075d1ac">CY_IPC_SEMA_OUT_OF_RANGE</ref>;</highlight></codeline>
<codeline lineno="365"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="366"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal">(retStatus);</highlight></codeline>
<codeline lineno="367"><highlight class="normal">}</highlight></codeline>
<codeline lineno="368"><highlight class="normal" /></codeline>
<codeline lineno="369"><highlight class="normal" /></codeline>
<codeline lineno="370"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="371"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_IPC_Sema_Status</highlight></codeline>
<codeline lineno="372"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="388"><highlight class="normal"><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1gaaa39cd088ef1e2ee9cd0555ae733c98f">Cy_IPC_Sema_Status</ref>(uint32_t<sp />semaNumber)</highlight></codeline>
<codeline lineno="389"><highlight class="normal">{</highlight></codeline>
<codeline lineno="390"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1ga64ee08d87c6d84e39749834cbdd6b7b9">cy_en_ipcsema_status_t</ref><sp /><sp /><sp />retStatus;</highlight></codeline>
<codeline lineno="391"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />semaIndex;</highlight></codeline>
<codeline lineno="392"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />semaMask;</highlight></codeline>
<codeline lineno="393"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp /><sp /><sp /><sp /><sp /><sp />*semaStruct;</highlight></codeline>
<codeline lineno="394"><highlight class="normal" /></codeline>
<codeline lineno="395"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />pointer<sp />to<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="396"><highlight class="normal"><sp /><sp /><sp /><sp />semaStruct<sp />=<sp />(<ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp />*)Cy_IPC_Drv_ReadDataValue(cy_semaIpcStruct);</highlight></codeline>
<codeline lineno="397"><highlight class="normal" /></codeline>
<codeline lineno="398"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(semaNumber<sp />&lt;<sp />semaStruct-&gt;maxSema)</highlight></codeline>
<codeline lineno="399"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="400"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />the<sp />index<sp />into<sp />the<sp />semaphore<sp />array<sp />and<sp />calculate<sp />the<sp />mask<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="401"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />semaIndex<sp />=<sp />semaNumber<sp />/<sp /><ref kindref="member" refid="group__group__ipc__sema__macros_1ga7c011c5126248439921e442aab3c6b23">CY_IPC_SEMA_PER_WORD</ref>;</highlight></codeline>
<codeline lineno="402"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />semaMask<sp />=<sp />(uint32_t)(1ul<sp />&lt;&lt;<sp />(semaNumber<sp />-<sp />(semaIndex<sp />*<sp />CY_IPC_SEMA_PER_WORD)<sp />));</highlight></codeline>
<codeline lineno="403"><highlight class="normal" /></codeline>
<codeline lineno="404"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">((semaStruct-&gt;<ref kindref="member" refid="structcy__stc__ipc__sema__t_1ad04fb13a0736977c4ddc642a630c9f54">arrayPtr</ref>[semaIndex]<sp />&amp;<sp />semaMask)<sp />!=<sp />0ul)</highlight></codeline>
<codeline lineno="405"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="406"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a920300a84a7ca2e96ce187423ac2eb18">CY_IPC_SEMA_STATUS_LOCKED</ref>;</highlight></codeline>
<codeline lineno="407"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="408"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="409"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="410"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9af009b6acf4579107d5384100f9f2e60c">CY_IPC_SEMA_STATUS_UNLOCKED</ref>;</highlight></codeline>
<codeline lineno="411"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="412"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="413"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="414"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="415"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />retStatus<sp />=<sp /><ref kindref="member" refid="group__group__ipc__sema__enums_1gga64ee08d87c6d84e39749834cbdd6b7b9a143eff28bd0bc98a860fce473075d1ac">CY_IPC_SEMA_OUT_OF_RANGE</ref>;</highlight></codeline>
<codeline lineno="416"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="417"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal">(retStatus);</highlight></codeline>
<codeline lineno="418"><highlight class="normal">}</highlight></codeline>
<codeline lineno="419"><highlight class="normal" /></codeline>
<codeline lineno="420"><highlight class="normal" /></codeline>
<codeline lineno="421"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="422"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_IPC_Sema_GetMaxSems</highlight></codeline>
<codeline lineno="423"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="434"><highlight class="normal">uint32_t<sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1gaf8dd9fc553a66939d37a988fa17eb3c1">Cy_IPC_Sema_GetMaxSems</ref>(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="435"><highlight class="normal">{</highlight></codeline>
<codeline lineno="436"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp /><sp /><sp /><sp /><sp /><sp />*semaStruct;</highlight></codeline>
<codeline lineno="437"><highlight class="normal" /></codeline>
<codeline lineno="438"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />pointer<sp />to<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="439"><highlight class="normal"><sp /><sp /><sp /><sp />semaStruct<sp />=<sp />(<ref kindref="compound" refid="structcy__stc__ipc__sema__t">cy_stc_ipc_sema_t</ref><sp />*)Cy_IPC_Drv_ReadDataValue(cy_semaIpcStruct);</highlight></codeline>
<codeline lineno="440"><highlight class="normal" /></codeline>
<codeline lineno="441"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(semaStruct-&gt;<ref kindref="member" refid="structcy__stc__ipc__sema__t_1a5f5f482e9c7bf7992001adb225f5d811">maxSema</ref>);</highlight></codeline>
<codeline lineno="442"><highlight class="normal">}</highlight></codeline>
<codeline lineno="443"><highlight class="normal" /></codeline>
<codeline lineno="444"><highlight class="normal" /></codeline>
<codeline lineno="445"><highlight class="normal" /><highlight class="comment">/*<sp />[]<sp />END<sp />OF<sp />FILE<sp />*/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_sema.c" />
  </compounddef>
</doxygen>